
\section{Introduction}
\paragraph*{Graph coloring problems}
Given a graph $G=(V,E)$, each vertex $v$ has a color set $C(v)$, a coloring $c$ of $G$ is an assignment of colors to all vertices in $V$ such that $c(v) \in C(v)$ for all $v \in V$. If for any edge $uv \in E$, we are given a bipartite graph between color sets $C(u), C(v)$ (whose edges imply incompatible pairs of colors), a conflict coloring $c$ is a coloring in which $c(u)c(v)$ is not an edge of the bipartite graph. The problem for deciding whether exists a conflict coloring of a given graph is called {\sc Conflict Coloring}.
%Observe that a proper coloring is a particular case of conflict coloring, then t
Observe that the classical problem {\sc (Proper) Coloring} is the case when the bipartite graph between color sets of any edge $uv$ only contains edges between the same two colors (the sets of colors are the same for every vertex).
In fact, a given bipartite graph for each edge gives a binary relation between the two endpoints of this edge. Hence {\sc Conflict Coloring} belongs to (binary) Constraint Satisfaction Problem ({\sc CSP}). These two problems are formally presented in Section~\ref{sec:models}. {\sc CSP} is a very general formalism to specify many problems in real life such as map-coloring, robotic~\cite{LP2014ACM}, scheduling~\cite{scheduling},\dots. It then has been widely studied  mostly in Artificial Intelligence and Operation Research.
The NP-completeness of {\sc CSP} motivates the interest in finding techniques to improve solvers (e.g. CPlex and Choco) which try to solve {\sc CSP} instances as fast and efficient as possible.
%Some typical solvers are CPlex, Choco,\dots. 
It is advantages to use available studies on {\sc CSP} to apply to {\sc Conflict Coloring} in particular and other combinatorial problems in general in application-side works. 

\paragraph*{Computational structural biology problems}
 {\sc Conflict Coloring} is motivated from problems in computational structural biology.
 %biologically structural determination, 
In~\cite{lasker2009inferential}, Discrete Optimization of Multiple INteracting Objects ({\sc Domino}) is introduced.
 A given assembly is modeled by a graph: one vertex for each subunit of the assembly and one edge for two interacting subunits, and a set of conformations associated with every subunit (vertex of the graph) and a score is associated with every pair of conformations for every edge of the graph.
The problem consists in determining a conformation per subunit such that the global score (a function depending on the set of all edge scores) is maximum.
It then can be formalized as a graph coloring problem by considering a conformation of a subunit as a color of the corresponding vertex. Hence, the (decision) coloring problem consists in finding a coloring such that the sum of the weights is at least a given lower-bound.
%
{\sc Domino} problem has been mostly studied from biology point of view and some works are related to computational approaches.
Despite the $\NP$-completeness of {\sc Domino}~\cite{np-cdomino}, there are methods to solve this problem with heuristic approaches, using tree decomposition~\cite{lasker2009inferential, domino-tw} or linear programming~\cite{LP-domino}. 
In this article, we study a new approach of {\sc Domino} in which the score function is relaxed, {\sc Conflict Coloring}.
 %which is formalized in Section~\ref{sec:models}.

 
\paragraph*{Application to biology context: structural determination of macromolecular assemblies}

All biological phenomena (cognition, immune response, metabolism, etc)
are based on structural description of macromolecular assemblies (MA):
complexes of interacting molecules (subunit), namely proteins or
nucleic acids~\cite{fersht1999structure}.  Structural studies of molecules  are then important to explain biological
functions. 
Structures of molecules and complexes may be ascribed to two levels of
resolution. At low resolution, the only information available may
consists of the pairwise interactions of the subunits in the MA.  A higher resolution, the relative position and orientation of the
individual subunits may be known. Such models culminate with atomic
resolution models, where individual atomic positions are known precisely.
%%
Because each atom has three Cartesian coordinates, such systems
involve hundreds of thousands of degrees of freedom. This high
dimensionality is naturally very challenging from the modeling
standpoint.
%%
Structure determination is equally challenging from the experimental /
structural biology standpoint.  There are a number of experimental
techniques which help providing structural information both at low and
high resolution.
 
Assume that the low resolution model provides the {\em interaction graph} of its subunits.
Also assume that a finite set of high resolution {\em conformations} has been computed for each
of the individual subunits and a {\em scoring function}
assessing the quality of the contact between two subunits positioned
in the assembly is available.
Determining a high resolution model of the MA
consists of choosing and assembling individual conformations for each
subunit (this correspond to {\sc Domino} problem).


\paragraph*{Our contributions and paper overview}
In this article, we study {\sc Conflict Coloring}, the new approach of {\sc Domino} in which the weight function is simplified (binary relations). This problem and variants are formally introduced in Section~\ref{sec:models}.
%We also consider some variants of this problem.
{\sc Conflict Coloring}  is a particular case of Constraint Satisfaction Problem ({\sc CSP}) which have studied in many communities. We provide some related works of its computational complexity approaches.
In Section~\ref{sec:complexity}, we establish a dichotomy of complexity ($\Poly$ / $\NP$-complete) for {\sc Conflict Coloring} and its variants.
Finally, in Section~\ref{sec:experiment}, we provide some experiments in which we build instances of {\sc Conflict Coloring} associated to {\em Voronoi diagram} in the plane: a graph is the Delauney triangulation with respected to finite Voronoi regions, colors of a vertex is a set of perturbations  of the corresponding Voronoi region. So for any two adjacent Voronoi regions, a perturbed polygon of the one can intersect one of the other. We then analysis dependencies of the existence of a solution to such intersection areas--thresholds for determining if a pair of perturbed polygons is conflict or not.
%\section{Introduction}
%%%i%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\paragraph*{Graph algorithms for determining high-resolution models of molecular assemblies}
%
%In this article, we investigate the problem of determining plausible structures of molecular assemblies.
%Following the approach introduced in~\cite{lasker2009inferential}, the assembly is modeled by a graph: one vertex for each subunit of the assembly and one edge for two interacting subunits.
%Furthermore, a set of conformations is associated with every subunit (vertex of the graph) and a score is associated with every pair of conformations for every edge of the graph, that is a score measuring the quality of the contact.
%The problem consists in determining a conformation per subunit such that the global score (a function depending on the set of all edge scores) is maximum.
%This problem, called \textsc{Domino}, generalizes graph coloring problems.
%Indeed, it consists in finding a coloring such that the sum of the weights is at least a given lower-bound (the colors are the conformations).
%
%{\sc Domino} problem has been mostly studied from biology point of view and some works are related to computational approaches.
%Despite the $\NP$-completeness of {\sc Domino}~\cite{np-cdomino}, there are methods to solve this latter problem with heuristic approaches, using tree decomposition~\cite{lasker2009inferential, domino-tw} or linear programming~\cite{LP-domino}.
%In this article, we attack the analysis of the binary version of {\sc Domino}, as formalized in Section~\ref{sec:models}.
%
%
%%Let $G = (V,E)$ be an interaction graph representing a given assembly in which $V$ represents the set of subunits and $E$ is the set of connections between subunits.
%
%
%%Let $k \geq 1$ be an integer.
%%We denote by $[k]$ the set of integers $\{1,2,\dots,k\}$.
%%For every $uv \in E$, the complete bipartite graph $K^{k}_{uv}$ is defined as follows:
%%$V(K^{k}_{uv}) = \{(u,i), i \in [k]\} \cup \{(v,j), j \in [k]\}$,
%%$E(K^{k}_{uv}) = \{(u,i)(v,j), i,j \in [k]\}$ with the weight function $w^{k}_{uv}: E(K^{k}_{uv}) \rightarrow \mathbb{R} \cup \{-\infty\}$.
%%In the following, we denote by $w^{k} = \{w^{k}_{uv}, uv \in E\}$ the set of weight functions over all the edges $uv \in E$.
%%For every vertex $v \in V$, the set $V(K^{k}_{uv})$ represents the $k$ possible conformations of the subunit associated with $v$.
%%For every $uv \in E$, the weight $w^{k}_{uv}( (u,i)(v,j) )$ represents the \emph{score} if the conformation of $u$ is $i$ and the conformation of $v$ is $j$.
%%The higher the score, the better the connection between the two associated subunits.
%%
%%
%%Let $G = (V,E)$ be an interaction graph.
%%A {\it $k$-coloring} is an application $c: V \rightarrow [k]$ that assigns to every vertex $v$ of $G$, an integer $c(v)$ in $[k]$ called its {\it color}.
%%Say otherwise, a coloring assigns to each subunit a conformation.
%%In the rest of the paper, we will use the term color instead of conformation.
%%
%%First of all, in general, the number of available colors at a vertex is not the same for all vertices.
%%However, we can easily transform such an instance so that all vertices have the same number $k$ of colors: it suffices to
%%add extra ``fake'' colors and to assign weight $-\infty$ to all edges incident with these colors in the graph $K_{uv}^k$.
%%%Thus, we only focus on graphs for which the set of possible colors is $[k]$ for every vertex.
%%
%%
%%%\medskip
%%%
%%%\noindent
%%%\textbf{Problems related to the sum of the weights.}
%%We are now able to formalize \textsc{Domino} in terms of graphs: it consists in finding a coloring such that the sum of the weights is at least a given lower-bound.
%%
%%
%%\medskip
%%
%%\noindent \fbox{\parbox{\textwidth}{ 
%%\textsc{Domino.}\\
%%\underline{Input}: A graph $G = (V,E)$, an integer $k \geq 1$, a set of weight functions $w^{k}$, and a real number $\gamma \in \mathbb{R}$. \\
%%\underline{Question}: Does there exist a coloring $c$ of $G$ such that $\sum\limits_{\substack{uv \in E}}%\\ i\in C(u), j\in C(v)}}
%%w^{k}_{uv}((u,c(u))(v,c(v))) \geq \gamma$ ?
%%}}
%%\medskip
%%
%%In structural biology, conformations of subunits are compatible according to the lock-and-key model. Thus, the total score of a set of conformations reflects whether the assembly defined by this set is well constructed and robust. It is the property used to define {\sc Domino}.
%%
%%{\sc Domino} is clearly in $\NP$. We can easily construct a reduction from $k$-coloring, as follows. Given a graph $G$, we define the weight function by taking, for any $uv \in E(G)$, $w^k_{uv}((u,i)(v,i)) = 0$ and $w^k_{uv}((u,i)(v,j)) = 1$ for $j\neq i$. Then $G$ is $k$-colorable if and only if it has a coloring $c$ with total weight at least $\gamma = |E(G)|$.
%
%
%
%
%
%
%%\paragraph*{General / CS - algorithmic intro.}
%
%
%%\begin{itemize}
%%\item general algo techniques
%%\item applications beyond biology?
%%\end{itemize}
%
%%Domino reconstruction problem: structure determination of large assemblies.
%
%
%
%
%\paragraph*{Biological motivation: modeling macromolecular assemblies.}
%
%All biological phenomena (cognition, immune response, metabolism, etc)
%are based on structural description of macromolecular assemblies (MA):
%complexes of interacting molecules (subunit), namely proteins or
%nucleic acids~\cite{fersht1999structure}.  As conveyed by the
%simplistic {\em lock-and-key} model, the association of two or more
%molecules forming a complex requires these partners to be
%complementary. In fact, structural studies of molecules are carried
%out under the {\em structure-dynamics-function paradigm}, as it is the
%structure and the dynamics of molecules which explain biological
%functions.  However, while genome sequencing projects have
%produced hundreds of millions of genes, there are only of the order of
%$10^5$ structures in the Protein Data Bank
%(\url{https://www.rcsb.org/}).  Thus, little is known in terms of
%macro-molecular interactions, at the structural level.
%%%
%Structures of molecules and complexes may be ascribed to two levels of
%resolution. At low resolution, the only information available may
%consists of the pairwise interactions of the subunits in the MA.  A
%higher resolution, the relative position and orientation of the
%individual subunits may be known. Such models culminate with atomic
%resolution models, where individual atomic positions are known
%precisely.
%%%
%Because each atom has three Cartesian coordinates, such systems
%involve hundreds of thousands of degrees of freedom. This high
%dimensionality is naturally very challenging from the modeling
%standpoint.
%%%
%Structure determination is equally challenging from the experimental /
%structural biology standpoint.  There are a number of experimental
%techniques which help providing structural information both at low and
%high resolution.
%
%\medskip
%
%\noindent
%\textbf{Reconstruction by data integration.}
%Native mass spectrometry is an experimental technique well suited
%to gather low resolution information. And the main techniques to gather high resolution information are X ray
%crystallography, nuclear magnetic resonance (NMR), an elite club
%recently joined by cryo-electron microscopy. 
%These techniques usually
%deliver static snapshots of molecules and complexes.  Therefore,
%understanding dynamic processes requires building and animate models from these
%static complexes.
%%%
%A convenient way to do so consists of synergizing two types of models,
%namely a low resolution model for a MA, and high resolution (atomic)
%models for its subunits. 
%Assume that the low resolution model
%provides the {\em interaction graph} of its subunits. Also assume that a
%finite set of high resolution {\em conformations has} been computed for each
%of the individual subunits.
%%%
%A route of choice to build a high resolution model of the MA consists
%of choosing and assembling individual conformations for each
%subunit. In doing so, we assume that a {\em scoring function}
%assessing the quality of the contact between two subunits positioned
%in the assembly is available.
%%%
%%%
%This problem was formalized using Discrete Optimization of Multiple
%INteracting Objects (\textsc{Domino}) in \cite{lasker2009inferential},
%so as to pick positions for the subunits maximizing a global utility
%function.
%
%\paragraph*{Contributions.}
%
%We first propose binary variants of \textsc{Domino} problem for which the quality of any contact between any two subunits is either \emph{admissible} or \emph{not admissible}, and so generalizing coloring problems in graphs
%We thus define {\sc Conflict $k$-Coloring} problem that consists of deciding whether there exists a set of conformations such that every contact is acceptable.
%We also formalize {\sc Fulfill $k$-Coloring} problem in which the number of acceptable contacts is at least a given value, and other versions of the problem (see Section~\ref{sec:models}).
%%
%We then establish the complexity dichotomies (polynomial vs $\NP$-complete) for these problems and some of their restrictions, and also study the relations with coloring problems and Constraint Satisfaction Problem ({\sc CSP}).
%%
%We finally experiment different parameters of the problem and our algorithms by generating geometric instances.
%More precisely, we use Voronoi diagram: subunits are internal points, conformations are generated by pertubating Voronoi vertices, and the quality of the contacts depends on the intersection of the obtained regions.
%We thus analyse the relationship between the existence of a solution and thresholds for determining if a contact between two conformations is admissible or not admissible.
%



\section{Models and related problems}
\label{sec:models}
%%i%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Let $G = (V,E)$ be an interaction graph representing a given assembly in which $V$ represents the set of subunits and $E$ is the set of contacts between them.
We label the set of conformations for each subunit to a color set of the corresponding vertex in $V$. 
We assume that every vertex has the same number of colors which is an integer $k$, hence the set of colors is $[k] = \{1,2,\dots,k\}$.
For every $uv \in E$, the scoring function provides the edge-weighted complete bipartite graph $K^{k}_{uv}$ which is defined as follows:
$V(K^{k}_{uv}) = \{(u,i), i \in [k]\} \cup \{(v,j), j \in [k]\}$,
$E(K^{k}_{uv}) = \{(u,i)(v,j), i,j \in [k]\}$,
and the weight function $w^{k}_{uv}: E(K^{k}_{uv}) \rightarrow \mathbb{R} \cup \{-\infty\}$.
We denote by $w^{k} = \{w^{k}_{uv}, uv \in E\}$ the set of weight functions over all the edges $uv \in E$.\\
Hence, 
for every vertex $v \in V$, the vertex set $\{ (v,i), i\in [k]\}$ represents the $k$ possible conformations of the subunit associated with $v$.
For every $uv \in E$, the weight $w^{k}_{uv}( (u,i)(v,j) )$ represents the \emph{score} between the $i$-conformation of $u$ and the $j$-one of $v$. Meaning by the scoring function, 
the higher the score, the better the connection between the two associated subunits.

In general, the number of colors is not the same for all vertices. However, we can easily change it so that all vertices have the same number $k$ of colors: it suffices to
add extra ``fake'' colors and to assign weight $-\infty$ to all edges incident with these colors in the graph $K_{uv}^k$. It explains our assumption of the same number of colors for all vertices.

%\medskip
%
%\noindent
%\textbf{Problems related to the sum of the weights.}
%We are now able to formalize \textsc{Domino} in terms of graphs: it consists in finding a coloring such that the sum of the weights is at least a given lower-bound.
%
%
%\medskip
%
%\noindent \fbox{\parbox{\textwidth}{ 
%\textsc{Domino.}\\
%\underline{Input}: A graph $G = (V,E)$, an integer $k \geq 1$, a set of weight functions $w^{k}$, and a real number $\gamma \in \mathbb{R}$. \\
%\underline{Question}: Does there exist a coloring $c$ of $G$ such that $\sum\limits_{\substack{uv \in E}}%\\ i\in C(u), j\in C(v)}}
%w^{k}_{uv}((u,c(u))(v,c(v))) \geq \gamma$ ?
%}}
%\medskip
%
%In structural biology, conformations of subunits are compatible according to the lock-and-key model. Thus, the total score of a set of conformations reflects whether the assembly defined by this set is well constructed and robust. It is the property used to define {\sc Domino}.

%{\sc Domino} is clearly in $\NP$. We can easily construct a reduction from $k$-coloring, as follows. Given a graph $G$, we define the weight function by taking, for any $uv \in E(G)$, $w^k_{uv}((u,i)(v,i)) = 0$ and $w^k_{uv}((u,i)(v,j)) = 1$ for $j\neq i$. Then $G$ is $k$-colorable if and only if it has a coloring $c$ with total weight at least $\gamma = |E(G)|$.




\subsection{Conflict coloring}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

An important constraint, from computational structural biology, consists in having a lower bound $\lambda \in \mathbb{R}$ on the weight of every edge $uv \in E$.
More precisely, the coloring $c$ must satisfy $w^{k}_{uv}((u,c(u)),(v,c(v))) \geq \lambda$ for every $uv \in E$.
This constraint may imply a stable structure of the macromolecular assembly, that is without ``bad connection'' between two subunits.

To take into account such a constraint, we define a {\it conflict $k$-graph} $M^{\lambda}_{uv}$ for every edge $uv \in E$ as follows.
$M^{\lambda}_{uv}$ is the subgraph of $K_{uv}^k$ such that $(u,c(u))(v,c(v)) \in E(M^{\lambda}_{uv})$ if and only if $w^{k}_{uv}((u,c(u)),(v,c(v))) < \lambda$.
%
We denote by $\mathcal{M}^{\lambda} = \{ M^{\lambda}_{e} \text{ for all } e \in E \}$, the {\it set of conflict $k$-graphs} ($k$-SoC).
%, if all color lists of vertices are $\mathcal{C}$ and $|\mathcal{C}|=k$, then we denote $k$-SoC $\mathcal{M}$.
An edge $uv \in E$ is {\it $\mathcal{M}^{\lambda}$-conflicting} for a $k$-coloring $c$ if $(u,c(u)) (v,c(v)) \in E(M^{\lambda}_{uv})$, otherwise it is {\it $\mathcal{M}^{\lambda}$-fulfilled}.


%An {\it $\mathcal{M}^{\lambda}$-conflict coloring} is a $k$-coloring of $G$ with no $\mathcal{M}^{\lambda}$-conflicting edge.

%To summarize, given a weight function $w^{k}$ and a real number $\lambda \in \mathbb{R}$, we obtain a SoC ${\M}^{\lambda}$.
%
The problem is then to solve the following problem with $\M=\M^{\lambda}$. 
\medskip


\noindent \fbox{\parbox{\textwidth}{ 
\textsc{Fulfill Coloring.} \\
\underline{Input}: A graph $G = (V,E)$, an integer $k$, a $k$-SoC $\M$, and a positive integer $q$. \\
\underline{Question}: Does there exist a $k$-coloring $c$ of $G$ with at least $q$ $\mathcal{M}$-fulfilled edges ?
}}\\[.2em]


%\noindent \fbox{\parbox{\textwidth}{ 
%\textsc{Fulfill Coloring.} \\
%\underline{Input}: A graph $G = (V,E)$, an integer $k \geq 1$, a weight function $w^{k}$, a real number $\lambda \in \mathbb{R}$, and an integer $q \geq 0$. \\
%\underline{Question}: Does there exist a coloring $c$ of $G$ with at least $q$ $\mathcal{M}^{\lambda}$-fulfilled edges ?
%}}\\[.5em]

%We define two different optimization versions of {\sc Fulfill coloring}.
%\begin{itemize} 
%\item {\sc Max-Min-Domino} consists in maximizing $\lambda$ such that $G$ is $\mathcal{M}^{\lambda}$-conflict colorable.
%\item {\sc Maximum Fulfill Coloring} consists in maximizing the number $q$ of $\mathcal{M}^{\lambda}$-fulfilled edges of $G$.
%\end{itemize}


\smallskip

An important particular case of this problem is when $q=|E|$. In that case, the problem, called {\sc Conflict Coloring}, is  to determine whether $G$  is {\it $\mathcal{M}$-conflict colorable}, that is whether it admits a $k$-coloring with no $\M$-conflict edges.
Such a coloring is called an {\it $\mathcal{M}$-conflict coloring}.  This notion of conflict coloring was introduced by Dvo\v{r}\'ak and Postle~\cite{DvPo17} and Fraigniaud et al.~\cite{FHK16}. 


We shall consider the restrictions of \textsc{Fulfill Coloring}, 
%{\sc Maximum Fulfill Coloring},
 and {\sc Conflict Coloring} to the case when $k$ is fixed. These are called {\sc Fulfill $k$-Coloring},
 % {\sc Maximum Fulfill $k$-Coloring}, 
 and  {\sc Conflict $k$-Coloring}, respectively. 


We finally define variants of {\sc Fulfill Coloring} and its restrictions, in which ${\M}$ is contained in some restricted family $\B$ of bipartite graphs.
For example, {\sc $\B$-Conflict $k$-Coloring} is the restriction of {\sc Conflict $k$-Coloring} in which each conflict $k$-graph  $M_{e}$ must belong to $\B$.
%\Ha{If the family consists of a unique graph $B$, then we abbreviate {\sc $\{B\}$-Conflict $k$-Coloring} to {\sc $B$-Conflict $k$-Coloring} => should be removed as we never use this in the paper}.
We denote by $\B(n,m)$ the class of subgraphs of $K_{n,n}$ with $m$ edges. Figure~\ref{fig:exemple-introduction} describes an instance of $\mathcal{B}(3,2)$-Conflict $3$-Coloring and a solution.
When $\B$ is the family of matchings (i.e. bipartite graphs with maximum degree $1$), {\sc $\B$-Conflict $k$-Coloring} is known
as {\it correspondence coloring} or {\it DP-coloring}. Since it is a generalization of the classical notions of coloring and list coloring, it has been extensively studied over the past five years (see e.g., \cite{Ber19,DvPo17,KiOz18a,LLYY19}).\\ 
%\cite{Ber16,Ber19,BeKo18,BKZ17,DvPo17,KiOz18a,KiOz18b,LLYY19}

\begin{figure}[t]
  \centerline{
  \includegraphics[scale=1]{figures/intro_example.pdf} }
  \caption{{\bf Example of conflict coloring.} A graph $G$ on four vertices (left) and a $3$-SoC $\M$ of $G$ (right) with 3 colors yellow, blue and red; $M_e \in \mathcal{B}(3,2)$: for every $e \in E(G)$ contains two edges. An $\M$-Conflict Coloring $c$ of $G$ is $c(a)=c(c)=c(d)=$ ``blue'', $c(b)=$``red''.
  Coloring $c$ is a solution of {\sc $\mathcal{B}(3,2)$-Conflict $3$-Coloring}.}
  \label{fig:exemple-introduction}
\end{figure}

\subsection{Relations to CSP}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%A generalization of {\sc (Proper) Coloring} is {\sc List coloring} which is formally defined as follows: for a graph $G$, a list assignment $L$ is a function from any vertex $v \in V(G)$ to $L(v)$ a list of colors; an $L$-coloring $c$ of $G$ is a proper coloring such that $c(v) \in L(v)$ for every $v\in V(G)$.
%The problem consists, given a graph $G$ and a list assignement $L$ to decide whether there is an $L$-coloring of $G$.
% A problem which is more general than {\sc List coloring} is {\sc Correspondence coloring} ({\sc DP-coloring}), first defined in \cite{DvPo17}. Given a graph $G$, a list assignment $L$ and a function $C$ from any edge $uv\in E(G)$ to a matching $C_{uv}$ of the complete bipartite graph $K^{L(u),L(v)}_{uv}$ (the vertex set is $\{ (u,i), i\in [L(u)]\} \cup \{(v,j), j\in [L(v)] \}$ and the edge set is $\{(u,i)(v,j), i\in [L(u)], j\in [L(v)]\}$. An $(L,C)$-coloring $c$ of $G$ is an $L$-coloring such that $(u, c(u))(v, c(v)) \not\in E(C_{uv})$ for every edge $uv \in E(G)$. Hence, {\sc DP-coloring} generalizes {\sc List coloring} which is when $C_{uv}$ contains only edges of the same colors in $L(u)$ and $L(v)$ for any $uv \in E(G)$. Furthermore {\sc DP-coloring} is a particular case of {\sc Conflict Coloring},
%since in this latter we can choose an arbitrary conflict graph rather than a matching.
%
%Complexity dichotomies of some generalizations of coloring problems have been obtained. A typical example is {\sc $H$-coloring}.
%\subsubsection{{\sc $H$-coloring} and Constraint Satisfaction Problem ({\sc CSP})}
%Let $H$ be a fixed graph (possibly directed and loops are allowed), whose vertices are {\it colors}. An $H$-coloring of a graph $G$ is a coloring $c$
%assigning to each vertex of $G$ a color of $H$, such that any two adjacent vertices in $G$ are colored by adjacent colors in $H$. This is actually a homomorphism $c: V(G) \rightarrow V(H)$ such that $c(u)c(v) \in E(H)$ for any $uv \in E(G)$. Observe that {\sc $k$-coloring} is the case when $H$ is the complete graph $K_k$. 
%For a fixed (directed) graph $H$, {\sc $H$-coloring} problem is to  decide whether a given (directed) graph $G$ admits an $H$-coloring. A complexity dichotomy for such problems with $H$ undirected has been known for several decades.
%\begin{theorem}[~\cite{HELL199092}]
%\label{thm:H-coloring}
%Let $H$ be an undirected graph. {\sc $H$-coloring} problem is polynomial-time solvable if $H$ is bipartite or has a loop, and $\NP$-complete otherwise.
%\end{theorem}
%%For directed graph, {\sc $H$-coloring} problems are equivalent to \emph{Constraint Satisfaction Problem}~\cite{csp-h}, as we present in the next section.
%

{\sc CSP} is a very general problem which an instance is defined by a triple $(\mathcal{V}, \mathcal{D}, \mathcal{C})$ where $\mathcal{V} = \{ V_1,\dots,V_n \}$ is a set of variables, $\mathcal{D} = \{D_1,\dots, D_n \}$ is a domain of values and $\mathcal{C} = \{C_1,\dots, C_m\}$ is a set of constraints. Each variable $V_i$ can take a value in its domain $D_i$. Every constraint $C_j$ is a triple $(r_j, t_j, R_j)$ where $r_j$ is a postive integer called \emph{arity} of the constraint, $t_j$ is an $r_j$-tuple of variables and $R_j$ is an $r_j$-ary relation on $t_j$. An \emph{evaluation} satisfies a constraint $(r_j, t_j, R_j)$ if the variables of $t_j$ are assigned values which satisfies $R_j$. An evaluation which satisfies all constraints is called a \emph{solution}.
Observe that {\sc $H$-coloring} and {\sc Conflict Coloring} are particular cases of binary {\sc CSP} where all constraints are binary relations (on variable domains corresponding to the vertex colors).

A finite constraint language $\Gamma$ is a finite domain and a finite set of relations over this domain. {\sc CSP($\Gamma$)} is the constraint satisfaction problem where instances are only allowed to use constraints in $\Gamma$.
%This problem is equivalent to some {\sc $H$-coloring} for some directed graph in \cite{csp-h} by Feder and Vardi in 1998. They conjectured that {\sc CSP($\Gamma$)} is either in $\Poly$ or $\NP$-complete (CSP conjecture). In 2017, this conjecture was independently proven by Zhuk~\cite{Zhuk} and Bulatov~\cite{Bulatov} and yielded the following corollary for {\sc $H$-coloring} with directed graph $H$. 
%\begin{corollary}
%For a fixed directed graph $H$, {\sc $H$-coloring} is either in $\Poly$ or $\NP$-complete. 
%\end{corollary}
%
%\subsubsection{{\sc Conflict Coloring} and comparisons to {\sc $H$-Coloring} and {\sc CSP}}
%For any graph $H$ with the vertex set $[k]$, we define the bipartite graph $B_H$ as follows: the vertex set is $A \cup B$ in which $A, B$ copies of $[k]$ and their vertices are respectively denoted by $i_A, j_B$ for $i,j\in [k]$; if there is an  (undirected) edge $ij\in E(H)$ (resp. directed $\overrightarrow{ij} \in E(H)$), then $i_Aj_B, i_Bj_A \in E(B_H)$ (resp. $i_Aj_B \in E(B_H)$). Thus, the problem {\sc $H$-Coloring} is equivalent to {\sc Conflict $k$-Coloring} with $k=|V(H)|$ and the $k$-SoC containing only the complement $\overline{B_H}$ of $B_H$ (\ie $V(\overline{B_H}) = V(B_H)$ and $E(\overline{B_H}) = \{ uv \mid \forall uv \not \in E(B_H) \}$), see Figure~\ref{fig:compare-coloring-H}. Hence, this problem is more general than {\sc $H$-Coloring} and even is its restriction {\sc $\mathcal{B}(k, |E(\overline{H})|)$-Conflict $k$-Coloring}.
%
%\begin{figure}[h!]
%\centerline{
%\includegraphics[scale=1.3]{figures/Hcoloring.pdf}}
%\caption{{\bf Convert {\sc $H$-coloring} to {\sc Conflict $|V(H)|$-Coloring.}} If $H_1=K_3$, then the corresponding conflict graph is a subgraph of $K_{3,3}$ which contains three edges of same colors (two leftmost). The conflict graph associated to the second graph $H_2$ contains conflict (incompatible) edges which are complement to $H$. Note that first two graphs $H$ are undirected, then their conflict graphs of an edge $uv$ are symmetric but it is not true if $H$ is directed, then it implicitly implies an orientation of edge $uv$ to apply the conflict graph to $uv$. An example is shown in the last graph $H_3$ directed and its conflict graph.}
%\label{fig:compare-coloring-H}
%\end{figure}

A bipartite conflict graph $M$ in a $k$-SoC $\M$ can be converted to a binary relation $R_M$ with $(c,c')\in R_M \iff (c,c')\notin E(M)$ for all $c,c'\in[k]$.
As a consequence we can reduce an instance of {\sc $k$-Conflict Coloring} to the instance of {\sc CSP} with variables $V(G)$ on domain $[k]$ and the set of constraints $\{ R_{M_{uv}}, uv\in E(G)\}$ corresponding to the conflict edges.
However, when $\M$ is restricted to a family $\mathcal{B}$ of bipartite graphs, the constraint language $\Gamma_\mathcal{B}=\{R_M, M\in\mathcal{B}\}$ gives a problem {\sc CSP($\Gamma_\mathcal{B}$)} with more instances than {\sc $\mathcal{B}$-Conflict $k$-Coloring}, in other words {\sc $\mathcal{B}$-Conflict $k$-Coloring} is a restriction of {\sc CSP($\Gamma_\mathcal{B}$)}. Indeed, in {\sc CSP($\Gamma_\mathcal{B}$)} we can choose arbitrary constraints among the relations and, in particular, multiple constraints on the same couple of variables; let say they are represented as conflict graphs $M_1,\dots,M_\ell$. So this would correspond in {\sc $\mathcal{B}$-Conflict $k$-Coloring} to a conflict graph for the same couple of vertices which is the \emph{union} of $M_1,\dots,M_\ell$ (because {\sc CSP} is a {\em conjunction} of constraints).
From this reasoning we deduce the following:

\begin{lemma}
If $\mathcal{B}$ is {\em closed by union}, \ie $M,M'\in\mathcal{B}\implies (M\cup M')\in\mathcal{B}$, then {\sc $\mathcal{B}$-Conflict $k$-Coloring} is equivalent to {\sc CSP($\Gamma_\mathcal{B}$)} with $\Gamma_\mathcal{B}=\{R_M, M\in\mathcal B\}$.
\end{lemma}

As a consequence, complexity upper bounds on {\sc CSP($\Gamma_\mathcal{B}$)} apply to {\sc $\mathcal{B}$-Conflict $k$-Coloring}, and complexity lower bounds on {\sc $\mathcal{B}$-Conflict $k$-Coloring} apply to {\sc CSP($\Gamma_\mathcal{B}$)}. 
In particular, when $\mathcal{B}$ is not closed by union, we cannot immediately apply the complexity lower bound results from {\sc CSP($\Gamma_\mathcal{B}$)}.

\subsection{Our contributions}
 %%%%%%%%%%%%%%%%%


We first study the computational complexity of {\sc Fulfill-$k$-Coloring}, {\sc Conflict-$k$-Coloring} and their restrictions on graph families $\mathcal{B}(k,m)$ in Section~\ref{sec:complexity}.

If for every $uv \in E(G)$, the edge set of $M_{uv}$ is the matching $\{ \{(u,i), (v,i)\} \mid i\in [k]\}$, then the graph is $\mathcal{M}$-conflict colorable if and only if it is $k$-colorable.
Therefore \textsc{$k$-Coloring} is a particular case of \textsc{Conflict $k$-Coloring}.
It is well-known that \textsc{$k$-Coloring} is $\NP$-complete if and only if $k \geq 3$. 
Henceforth, the problems \textsc{Conflict $k$-Coloring} and \textsc{Fulfill $k$-Coloring} are $\NP$-complete for all $k\geq 3$.
Thus, the problems \textsc{Conflict Coloring} and \textsc{Fulfill Coloring} are $\NP$-complete.
We prove in Theorem~\ref{thm:2CC} that \textsc{Conflict $2$-Coloring} is polynomial-time solvable.
On the other hand, \textsc{Fulfill $2$-Coloring} is more general than \textsc{Max Cut} (decision version). This problem is given a graph and an integer, and aims to determine whether there is a partition of vertices into two disjoint sets such that there number of edges between them is at least the number. It is known to be $\NP$-complete~\cite{Karp72}.
%\footnote{When we restrict to any edge $e$, the conflict $k$-graph $M_e$ contains two edges whose two endvertices have the same colors.}.
Therefore \textsc{Fulfill $2$-Coloring} is also $\NP$-complete.

We next study  \textsc{$\mathcal{B}(k,m)$-Fulfill $k$-Coloring} and \textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring}. We prove polynomial vs. $\NP$ dichotomy results with respect to the considered values $k$ and $m$. All those complexity results are summarized in Table~\ref{tab:coloring}.
\begin{remark}
Given a coloring, we can easily check whether it satisfies the problems {\sc Fulfill-Coloring} or {\sc Conflict-Coloring} in polynomial time. Thus, these two problems are in $\NP$ and we only prove the $\NP$-hardness of a $\NP$-complete result.
\end{remark}

\smallskip

\begin{table}[!ht]
\centering{
\begin{tabular}{|l|c|c|}
  \hline
   & {\sc Fulfill $k$-Coloring} & {\sc Conflict $k$-Coloring}   \\
  \hline
$k=1$ & polynomial  & polynomial \\
$k=2$ &  $\NP$-complete & polynomial \\
$k\geq 3$ &  $\NP$-complete & $\NP$-complete\\
\hline
  \hline
    & {\sc $\B(k,m)$-Fulfill $k$-Coloring} & {\sc $\B(k,m)$-Conflict $k$-Coloring}   \\
  \hline
$m=0$ & polynomial & polynomial \\
$1\leq m \leq k^2-3$ & $\NP$-complete   &  $\NP$-complete \\
$m \in \{k^2-1, k^2-2\}$ & $\NP$-complete   & polynomial \\
$m=k^2$ & polynomial & polynomial \\
\hline
\end{tabular}
\caption{{\bf Dichotomy results on conflict coloring.}}
\label{tab:coloring}
}
\end{table}

\medskip

The next section describes  experimentation works. We first introduce our setup to build (geometric) instances of {\sc Conflict Coloring} and then present some statistics which we obtain from our experiments.
Namely, instances of {\sc Conflict Coloring} are  associated with {\em Voronoi diagrams} in the plane in which we retain as vertices those data points have a finite Voronoi region. 
 Then, we build a $k$-SoC $\M$ by generating a set of $k$ (randomly) perturbed polygons of the finite Voronoi polygon of a point, and given an intersection area threshold $\tau_c$, a conflict between two perturbed  polygons of adjacent Voronoi regions is when their intersection area is greater than $\tau_c$ (detail in Section~\ref{sec:experiment-intro}). Hence, a random instance and a threshold $\tau_c$ yield a set of conflicts. The obtained statistics provide information on the relationship between the existence of a solution and thresholds which are derived from some local conditions.
 

\medskip

We also study on algorithms for solving the coloring problems and {\sc Domino} which this work is not presented in this paper but you can see in \cite{Ha-thesis}. 


\section{Complexity of the problems}\label{sec:complexity}
%%i%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

The aim of this chapter is to prove results in Table~\ref{tab:coloring}.

\subsection{Unrestricted conflict coloring}
We first establish the complexity of \textsc{Conflict $k$-Coloring} and \textsc{Fulfill $k$-Coloring}, and then consider the restrictions of the problems to the family $\mathcal{B}(k,m)$.

\textsc{Conflict $1$-Coloring} and \textsc{Fulfill $1$-Coloring} are trivial: there is only one possible color for each vertex, we just need to check which edges $e$ are fulfilled, that is such that $M_e$ is edgeless.\\
We now consider \textsc{Conflict 2-Coloring} and obtain the following.

\begin{theorem}\label{thm:2CC}
\textsc{Conflict 2-Coloring} is polynomial-time solvable.
\end{theorem}

\begin{proof}
Let $G = (V,E)$ be a graph and let $M_{uv}$ be the conflict $2$-graph for each  edge $uv \in E$.
If there is an edge $e \in E$ such that $M_{e} = K_{2,2}$, then the answer is `No' because $e$ cannot be fulfilled.
If there is an edge $e \in E$ such that $M_{e} = K_{2,0}$ (edgeless graph), then $e$ is always fulfilled.
Without loss of generality, we assume that the conflict $2$-graph of every edge is neither $K_{2,2}$ nor $K_{2,0}$. \\
Now, from $G$ and the set of conflict $2$-graphs $M_{uv}$ for each edge $uv \in E$, we  construct a {\sc $2$-Sat} formula $\Phi$ as follows.

\begin{enumerate}
\item For a vertex $v \in V$ and a color in $\{1,2\}$, create a variable $x_{v}$ for $(v,1)$ and $\bar{x}_v$ for $(v,2)$. So we denote by $\ell^i_v$ a literal of variable $x_v$, in which $\ell^1_v=x_v$ and $\ell^2_v=\bar{x}_v$.

\item For an edge $uv \in E$ with $M_{uv}$, we create a clause gadget $C_{uv} =  \bigwedge\limits_{(u,i)(v,j)\in E(M_{uv})} (\bar{\ell}^i_u \vee \bar{\ell}^j_v) $.
\end{enumerate}

We will prove that G admits a conflict coloring $c$ if and only if there is an assignment $\phi$ satisfying $\Phi$.\\ 
Observe that, for any $uv \in E(G)$, the clause gadget $C_{uv}$ contains a clause for each edge $(u,i)(v,j) \in M_{uv}$ which is the negation of $(\ell^i_u \wedge \ell^j_v)$. It implies that $c$ does not conflict on $uv$ by edge $(u,i)(v,j) \in M_{uv}$ if and only if $\neg(\ell^i_u \wedge \ell^j_v)$ is satisfiable by $\phi$. Thus, $uv$ is fulfilled by $c$ if and only if $C_{uv}$ is satisfiable by $\phi$.\\
Therefore, one can determine $c$ from $\phi$ by taking $c(v) = 1$ (resp. $c(v) = 2$) if $\phi (x_v) = true$ (resp. $\phi (x_v) = false$).
\end{proof}



In contrast to \textsc{Conflict $2$-Coloring}, \textsc{Fulfill 2-Coloring} generalizes the well-known $\NP$-complete problem \textsc{Max Cut}, and thus it is also $\NP$-complete.  For $k \geq 3$, \textsc{Conflict $k$-Coloring} generalizes the $\NP$-complete problem \textsc{$k$-Coloring} and so is $\NP$-complete. Hence, \textsc{Fulfill $k$-Coloring} is also $\NP$-complete. 

\begin{proposition}
\textsc{Conflict $k$-Coloring} is $\NP$-complete for all $k\geq 3$. \textsc{Fulfill $k$-Coloring} is $\NP$-complete for all $k\geq 2$.


\end{proposition}
%The problem \textsc{ conflict 2-coloring} is polynomial-time solvable as shown in the previous section. In this section, we consider the maximization problem on two colors. We have that \textsc{max $\mathcal{B}(2, 2)$-Fulfill 2-Coloring} is $\NP$-complete as a generalization of \textsc{ MAXCUT} problem, then \textsc{ max fulfill 2 coloring} is $\NP$-complete. Then first, we consider the complexity of the maximization problem on a precise conflict subgraph $M_{e}= B(2,m)$. We have that \textsc{max $\mathcal{B}(2, m)$-Fulfill 2-Coloring} for $m=\{0,4\}$ are trivially polynomial time solvable, and for $m=2$ is known to be in $\NP$-complete. It remains two cases when $M_e = B(2, 3)$ and $M_e= B(2,1)$.

\subsection{Restrictions to the family $\B(k,m)$}

Now, we look at the restrictions of those problems when every conflict $k$-graph $M_e$ is in $\B(k,m)$, that is a bipartite graph with $k$ vertices in each part and $m$ edges. We assume that $k\geq 2$. If $m=0$ (resp. $m=k^2$), then the conflict $k$-graphs are edgeless (resp. complete bipartite) and so every $k$-coloring fulfills all edges (resp. no edges). Hence  \textsc{$\B(k,0)$-Fulfill $k$-Coloring} and \textsc{$\B(k,k^2)$-Fulfill $k$-Coloring} are trivially polynomial-time solvable.

When $k=2$, \textsc{$\mathcal{B}(2,m)$-Conflict $2$-Coloring} is in $\Poly$ by Theorem~\ref{thm:2CC}. We prove the following for \textsc{$\mathcal{B}(2,m)$-Fulfill $2$-Coloring}.
\begin{theorem}\label{thm:complexity_2colors}
\textsc{$\mathcal{B}(2,m)$-Fulfill $2$-Coloring}  is $\NP$-complete for $m \in \{1,2,3\}$.
\end{theorem}

\begin{proof}
An easy observation is that \textsc{$\mathcal{B}(2,2)$-Fulfill 2-Coloring} is $\NP$-complete since it generalizes \textsc{Max Cut}. Thus, we now prove for graph classes $\mathcal{B}(2,1)$ and $\mathcal{B}(2,3)$.
\medskip

\noindent 1. \textsc{$\mathcal{B}(2, 1)$-Fulfill 2-Coloring} is $\NP$-hard.

A reduction from \textsc{Max-2-Sat} problem which is known to be $\NP$-hard~\cite{GJS76}.\\
Given a {\sc $2$-Sat} formula $\Phi$ with $N$ variables $x_1,\dots, x_N$ and $l$ clauses, each contains exactly 2 literals. We construct a graph $G$ and the conflict $2$-graph $M_e$ for any $e \in E(G)$ as follows (see Figure \ref{fig:construction} for an example):

\begin{figure}[h!]
  \centerline{\raisebox{.5cm}{\includegraphics[scale=1]{figures/ex_graph2.pdf}}
  \hspace*{1cm}
  \includegraphics[scale=.8]{figures/ex_subgraph2.pdf} }
  \caption{{\bf An example of the construction for $\Phi = (x_1 \vee x_2) \wedge (\bar{x}_2 \vee x_3))$.} The graph $G$ (left)  and the corresponding conflict $2$-graphs of edges in the dashed box (colors 1, 2 are respectively blue, red).}
  \label{fig:construction}
\end{figure}

\begin{itemize}
\item For each variable $x_t$, we create a vertex $v_t$, and if $x_i$ appears in $\alpha_t$ clauses, then we create three copies $v^r_{t1}, v^r_{t2}, v^r_t$ for each $r$-occurrence of $x_t$, $r\in [\alpha_t]$. We add edges $v^r_{t1}v^r_t, v^r_{t2}v^r_t$ to $E(G)$; and $(v^r_{t1},1)(v^r_t,2) \in M_{v^r_{t1}v^r_t}$ and $(v^r_{t2},2)(v^r_t,1)\in M_{v^r_{t2}v^r_t}$. 
 For $r\in [\alpha]$, we create a cycle on vertices $v_t, v^r_{t1}, v^r_{t2}$, and for (ordered edge) $uv \in \{ v_{t}v^r_{t1}, v^r_{t1}v^r_{t2}, v^r_{t2}v_{t}  \}$, $M_{uv}$ contains only edge $(u,2)(v,1)$. For conveniences, we call the subgraph on four vertices $v_t, v^r_{t1}, v^r_{t2}, v^r_{t}$ is a {\em $v^r_t$-graph} for every $r \in [\alpha_t]$.

\item For each clause, assume that $C = (\ell_1 \vee \ell_2)$ where $\ell_1, \ell_2$ are respectively the $r_1$-th occurrence of $x_p$, $r_2$-th occurrence of $x_q$ in $C$. We add to $E(G)$ the clause edge $e= v^{r_1}_pv^{r_2}_q$, and create its conflict $2$-graph $M_e$ as follows:
	\begin{itemize}
		\item If $\ell_1 = x_p$ and $\ell_2 = x_q$, then $(v^{r_1}_p,2)(v^{r_2}_q,2)  \in M_e$.
	 	\item If $\ell_1 = x_p$ and $\ell_2 = \bar{x}_q$, then $(v^{r_1}_p,2)(v^{r_2}_q,1) \in M_e$.
	 	\item If $\ell_1 = \bar{x}_p$ and $\ell_2 = x_q$, then $(v^{r_1}_p,1)(v^{r_2}_q,2) \in M_e$.
	 	\item If $\ell_1 = \bar{x}_p$ and $\ell_2 = \bar{x}_q$, then $(v^{r_1}_p,1)(v^{r_2}_q,1) \in M_e$.
	\end{itemize}
\end{itemize}
We shall prove that $\Phi$ admits an assignment which satisfies at least $k$ clauses if and only if there is a $2$-coloring $c$ which fulfills at least $10l+k$ edges of $G$.

Assume that we have an assignment $\phi$ satisfying at least $k$ clauses of $\Phi$. Then, we take a coloring as follows:
	\begin{itemize}
		\item[-] if $x_t = true$ (resp. $false$), then $c(v_{t}) = 1$ (resp. $c(v_{t}) = 2$).
		\item[-] all its copies $v^{r}_{t1}, v^r_{t2}, v^r_{t}$ for $r\in [\alpha_t]$ have color $c(v_t)$.
	\end{itemize}
We now check that there are at least $10l+k$ fulfilled edges in $G$. Indeed, for each satisfied clause, the corresponding clause edge in $E(G)$ is fulfilled, then we have at least $k$ such edges.
For each variable $x_t$, and $r\in [\alpha_t]$, the $v^r_t$-graph has all 5 fulfilled edges. There are $2l$ such graphs which have totally $10l$ fulfilled edges. Therefore, $c$ fulfills at least $k+10l$ edges of $G$.


Conversely, let a coloring $c$ which fulfills at least  $10l+k$ edges of $G$.
\begin{remark}\label{rmk:v_i^j graph}
We can easily check the following: all five edges in a $v^r_t$-graph are fulfilled if and only if its four vertices have the same colors.
\end{remark}

\begin{claim}\label{claim:2M_type1}
There is always a coloring $c$ such that it fulfills all edges of $v^r_t$-graphs (for $t\in [N], r \in [\alpha_t]$).
\end{claim}
\begin{subproof}
Assume a coloring in which there is a $v^r_t$-graph which has a conflict edge.
Observe that if $v^r_t$ has at least two conflict edges or the clause edge at $v^r_t$ is conflict, then we can fulfill all edges of $v^r_t$-graph by Remark~\ref{rmk:v_i^j graph} and obtain more fulfilled edges which contradicts to the maximality of $c$. 
Hence, $v_r^t$-graph contains only one conflict edge and the clause edge at $v^r_t$ is fulfilled by $c$. We can fulfill all edges of this graph by changing the color of $v_r^t$, which leads to the following cases:
\begin{enumerate}
\item The clause edge $v_i^ju^j$ is still fulfilled, and we obtain more fulfilled edges which is a contradiction (Figure~\ref{fig:replace_edge1234}). 
\begin{figure}[h!]
  \centerline{\raisebox{.5cm}{\includegraphics[scale=1]{figures/replace_edge1.pdf}}
  \includegraphics[scale=.8]{figures/replace_edge3.pdf} \hspace*{1.5cm}
  \raisebox{.5cm}{\includegraphics[scale=1]{figures/replace_edge2.pdf}}
  \includegraphics[scale=.8]{figures/replace_edge4.pdf}}
  \caption{Corresponding to a color at each vertex, $v^r_t$-graph has one conflict (dashed) edge and the clause edge at $v^r_t$ is fulfilled (left). After changing the color of $v^r_t$,  the clause edge is still fulfilled and all edges of $v^r_t$-graph are now fulfilled (right).}
  \label{fig:replace_edge1234}
\end{figure}

\item  The clause edge at $v^r_t$ changes to a conflict edge, and we still have the same number of fulfilled edges of $G$ (Figure~\ref{fig:replace_2edge1234}).
\begin{figure}[h!]
  \centerline{
  \raisebox{.5cm}{\includegraphics[scale=1]{figures/replace_2edge1.pdf}}
  \includegraphics[scale=.8]{figures/replace_2edge2.pdf} \hspace*{1.5cm}
  \raisebox{.5cm}{\includegraphics[scale=1]{figures/replace_2edge3.pdf}}
  \includegraphics[scale=.8]{figures/replace_2edge4.pdf}}
  \caption{The case after changing the color of $v^r_t$, the clause edge becoms a conflict (dashed) edge and all edges of $v_r^t$-graph are now fulfilled (right).}
  \label{fig:replace_2edge1234}
\end{figure}
\end{enumerate}
Therefore, there is a coloring which fulfills all edges of $v^r_t$-graphs.
\end{subproof}\\ 
From a coloring $c$ satisfying Claim~\ref{claim:2M_type1}, we define $\phi$ by taking $\phi(x_t)=true$ (resp. $false$) if $c(v_t) = 1$ (resp. $c(v_t) = 2$). Since $c$ fulfills all edges of $v^r_t$-graphs ($10l$ in total), then $c$ fulfills at least $k$ clause edges in $G$. Thus, $\phi$ satisfies at least $k$ clauses of $\Phi$.

\bigskip

\noindent 2. \textsc{$\mathcal{B}(2, 3)$-Fulfill 2-Coloring} is $\NP$-hard.

We reduce from \textsc{3-Sat}.
Given a formula $\Phi$ of this problem with $N$ variables $x_t$, $t\in [N]$ and $l$ clauses $C_i$, $i\in [l]$, we construct a graph $G$ and $M_e$ for any $e \in E(G)$ as follows (see Figure \ref{fig:construction_B(2,3)} for an example).

\begin{figure}[ht]
  \centerline{\raisebox{.5cm}{\includegraphics[scale=.8]{figures/graph_B(2,3).pdf}}
  \hspace*{1cm}
  \includegraphics[scale=.8]{figures/subgraph_B(2,3).pdf} }
  \caption{{\bf An example of the construction in the reduction.} The graph $G$ (left) which is associated to $\Phi = (x_1 \vee \bar{x}_2 \vee x_3) \wedge (x_2 \vee \bar{x}_3 \vee \bar{x}_4)$ and an example of graphs $M_e$ for $e\in E(G)$. Note color 1 (resp. 2) is presented as blue (resp. red).}
  \label{fig:construction_B(2,3)}
\end{figure}

\begin{itemize}
\item For each variable $x_t$, create a vertex $v_t \in V(G)$.
\item For each clause $C_i$, we create a {\em clause gadget $X_i$} which contains six vertices $c^i_1,\dots, c^i_6$. We add (ordered) edges $c^i_4c^i_5, c^i_5c^i_6, c^i_6c^i_4$ and for each edge $uv$ of them, $M_{uv}$ has three edges which are not $(u,1)(v,2)$. And add (ordered) edges 
  $c^i_1c^i_4, c^i_2c^i_5, c^i_3c^i_6$ and for each edge $uv$ of them,  $M_{uv}$ has three edges which are not  $(u,2)(v,2)$. 
If $C_i =(\ell_1 \vee \ell_2 \vee \ell_3)$ where each $\ell_i$ is a literal of variable $x_{t_i}$, we then add a set $Y_i$ of {\em variable-clause edges} $v_{t_1}c^i_1, v_{t_2}c^i_2, v_{t_3}c^i_3$. For $j\in [3]$, $M_{v_{t_j}c^i_j}$ has three edges which are not $(v_{t_j},1)(c^i_j,1)$  (resp. $(v_{t_j},2)(c^i_j,1)$ ) if $\ell_j = x_{t_j}$ (resp. $\ell_j = \bar{x}_{t_j}$). For conveniences, for a clause $C_i$, the edge set which contains all edges of $X_i$ and $Y_i$ is called {\em clause-edge set}, denoted by $S_i$.
\end{itemize}
 We can easily check by hand the following.

\begin{claim}\label{claim:B(2,3)}
For each clause $C_i$, a coloring fulfills no edges in $Y_i$ if and only if it can fulfill at most three edges in $S_i$. 
Furthermore, there exists a coloring which fulfills four edges in $S_i$ in which at least one of them is in $Y_i$. 
\end{claim}

We shall show that there is $\phi$ satisfying $\Phi$ if and only if there is a 2-coloring of $G$ with $4l$ fulfilled edges. The idea is that a variable $\phi(x_t) = true$ (resp. $false$) when $c(v_t)=1$ (resp. $c(v_t)=2$),  and a literal $\ell_j = x_t$ (resp. $\ell_j = \bar{x}_t$) is true in a clause $C_i$ when the edge $v_tc^i_j\in Y_i$ is fulfilled and then $v_t$ is colored 1 (resp. 2).

Assume that there is an assignment $\phi$ satisfying $\Phi$.  We define a coloring $c$ of $G$ by taking $c(v_t) = 1$ if $\phi(x_t) = true$ or $c(v_t) = 2$ if $\phi(x_t) = false$, and we complete $c$ such that if $C_i$ is true, then $c$ fulfills four edges of $S_i$ which includes the variable-clause edge of every true literal in $C_i$; otherwise, $c$ fulfills three edges in $S_i$ and none of them  is in $Y_i$. This can be done by Claim~\ref{claim:B(2,3)}.  Since there are $l$ clauses of $\Phi$ which are true, then $c$ fulfills $4l$ edges.

Conversely, assume that we have a 2-coloring $c$ of $G$ with $4l$ fulfilled edges. By Claim~\ref{claim:B(2,3)}, $c$ must fulfill at least one edge in $Y_i$ for any clause $C_i$. As a consequence, we obtain $\phi$ by taking $\phi(x_t) = true$ (resp. $false$) if $c(v_t) = 1$ (resp. 2), hence $\phi$ satisfies $\Phi$.
\end{proof}

\begin{remark}\label{rem:NP}
\textsc{Max Cut} can be solved in polynomial time for planar graphs~\cite{Had75}. In contrast, \textsc{$\B(2,3)$-Fulfill 2-Coloring} is $\NP$-complete on planar graphs by reducing from {\sc Planar 3-Sat} which is $\NP$-complete~\cite{planar3sat} with the same reduction in Theorem~\ref{thm:complexity_2colors}-2.
\end{remark}


%\begin{corollary}
%\textsc{ Fulfill 2-Coloring} is $\NP$-complete even on planar graphs.
%\end{corollary}

When $k \geq 3$, we use reductions from \textsc{$k$-Coloring} to establish the following. 

\begin{theorem}\label{thm:complexity_(k,m)}
Let $k\geq 3$ be an integer.
If $1 \leq m \leq k^2-3$ then
\textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring}  is $\NP$-complete, and if  $m = \{ k^2-1, k^2-2\}$ then it is polynomial-time solvable.
\end{theorem}

The proof is separated to several cases depending of $m$.

{\bf Polynomial cases when $m\in \{k^2-1, k^2-2\}$.} Given a graph $G$, we shall find a conflict $k$-coloring $c$ of $G$ if it exists.
\begin{description}
	\item If $m=k^2-1$, in order to fulfill an edge $uv \in E$, we have to take $c(u) = i, c(v) = j$ for the only edge $(u,i)(v,j) \not \in M_{uv}$. If we can assign a color to every vertex, then we obtain a conflict $k$-coloring of $G$. Otherwise, $G$ is not conflict colorable.

\item If $m = k^2-2$, the problem can be solved as follows.
Initially, let $\tilde{c}(v) = \emptyset$ for every $v \in V$.
We sequentially apply the following rules for all vertices.
\begin{description}
	\item[Rule 1:] 
For every edge $uv \in E$, if there is $i\in [k]$ such that the two edges $(u,i)(v,j_1), (u,i)(v,j_2) \not \in M_{uv}$, then $\tilde{c}(u) :=  \tilde{c}(u) \cup \{i\}$.
	\end{description}
If there is a vertex $v$ such that $|\tilde{c}(v)| \geq 2$, then there is no coloring $c$ because $v$ needs two colors to fulfill all its incident edges.
Otherwise, let $S = \{v \in V \mid |\tilde{c}(v)|=1\} \subseteq V$.\\
We sequentially apply the following for all vertices $V\setminus S$. 
	\begin{description}
	\item[Rule 2:] For every vertex $v$ with all its neighbors $\{u_1,\dots, u_q\}$ and for every color $i \in [k]$ such that $(v,i)(u_j,c_j) \not \in M_{vu_j}$ for all $j\in [q]$ and some $c_j \in [k]$, 
then we set $\tilde{c}(v) := \tilde{c}(v) \cup \{i\}$.
	\end{description}
Observe that $|\tilde{c}(v)| \leq 2$ for every $v \in V$.
If there is a vertex $v \in V$ such that $\tilde{c}(v) = \emptyset$, then there is no conflict coloring for $G$ because there is no color for $v$ that allows to fulfill all its incident edges.
Without loss of generality, we assume that  $G[V\setminus S]$ is connected (otherwise, we repeat the following for all the connected components).
There are two cases:
\begin{itemize}
\item[\rm (i)] If there is a vertex $v \in V \setminus S$ such that $|\tilde{c}(v)| = 1$,
let $(v_{1} = v, v_{2}, \ldots, v_{t})$ be the ordering obtained by a breadth-first search algorithm in $G[V \setminus S]$.
By construction of $S$, and $V \setminus S$, this ordering gives a unique color for all vertices of $V \setminus S$, that is $c(v_{1}) = \tilde{c}(v_{1})$, and $c(v_{i}) = c_i$ with $c_i$ the unique color such that $(v_{i-1},c(v_{i-1}))(v_i,c_i) \not \in M_{v_{i-1}v_{i}}$ for every $i \in \{2, \ldots, t\}$.
Finally, once the colors $c(v)$ have been determined for all vertices $v \in V$, we have to verify if all the edges of $E$ are fulfilled.
\item[\rm(ii)] If $|\tilde{c}(v)| = 2$ for every $v \in V \setminus S$, take any vertex $v \in V \setminus S$ and fix one color $c(v) \in \tilde{c}(v)$ and apply the procedure above in (i).
If there is a coloring that fulfills all edges, then it terminates. 
Otherwise, apply the procedure in (i) for the other color in $\tilde{c}(v)$.
Hence either we find  a conflict $k$-coloring or $G$ has no such a coloring.
\end{itemize}
\end{description}  

 \medskip 
  
\noindent {\bf The $\NP$-completeness when $m \in [k^2-3]$.}
 We denote by $[a,b]$ for $a \leq b$ the set of integers $\{a,a+1,\dots,b\}$.
For an edge $uv$, we reuse the notation $K^k_{uv}$ which is the complete bipartite with the vertex set $V(K^{k}_{uv}) = \{(u,i), i \in [k]\} \cup \{(v,j), j \in [k]\}$ and 
$E(K^{k}_{uv}) = \{(u,i)(v,j), i,j \in [k]\}$.\\
We reduce from {\sc $k$-Coloring} and the proof includes the three following cases.
\medskip

\noindent {\bf Case 1:} $ \dfrac{k}{2} \leq m \leq  (k-1)^2$:\\
Given a graph $G=(V,E)$ of {\sc $k$-Coloring}, we construct, for \textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring}, a graph $G' = (V',E')$ and a $k$-SoC $\M$ as follows (Figure~\ref{fig:ccnp-case1}): 
\begin{itemize}
\item For each  $v \in V$, we add to $V'$ a vertex $v'$, and for each edge $uv \in E$, add $k$ vertices $a^{uv}_1,\dots, a^{uv}_k$. We set $E'_{uv} = \{ua^{uv}_i, va^{uv}_i \mid i\in [k] \}$ and add it to $E'$.
\item For any $uv \in E$ and $i\in [k]$, $M_{ua^{uv}_i}$ contains $t= \min \{m, k-1 \}$ edges $(u,i)(a^{uv}_i,j)$ for $j\in [t]$ and $t'= m -(k-1)$ (if $t'>0$) edges of $B_u$ where $B_u$ is the complete bipartite graph whose vertex sets are $ \bigcup_{j\in [k]\setminus \{i\} } \{(u,j)\}$ and  $\bigcup_{j\in [2,k-1]}\{ (a^{uv}_i,j) \}$. The conflict graph $M_{va^{uv}_i}$ contains $t$ edges
 $(v,i)(a^{uv}_i,k),\dots,(v,i)(a^{uv},k-t+1)$ and $t'$ (if $t' >0$) edges of $B_v$ where $B_v$ is the complete bipartite graph whose vertex sets are 
  $\bigcup_{j\in [k]\setminus \{i\} } \{(v,j)\}$ and $\bigcup_{j\in [2,k-1]}\{ (a^{uv}_i,j)\}$.
\end{itemize}
\begin{figure}[h!]
\centerline{
\includegraphics[scale = .8]{figures/construct(k,m)_1.pdf}
\hspace*{2cm}
\includegraphics[scale=1.2]{figures/B(k,m)_1.pdf}}
\caption{{\bf An example of the construction when $k = 5$.} An edge $uv \in E$ and its set $E'_{uv}$ (left). The conflict $k$-graphs of red edges $ua^{uv}_3, va^{uv}_3$ when $m=3$ (third graph); and if $m > 4$, there are $t=4$ black edges and the $t' = m -k+1$ other edges are chosen among grey edges (rightmost).}
\label{fig:ccnp-case1}
\end{figure}
Observe that by the construction of the set $\M$, the value $m$ is at most $(k-1)^2$, because for any edge $uv \in E$ and $i\in [k]$, $M_{ua^{uv}_i}$ and  $M_{va^{uv}_i}$ contains at most $k-1 + |E(B_u)| = k-1 + |E(B_u)|=(k-1)^2$ edges.


We shall prove that $G$ is $k$-colorable if and only if $G'$ is $\M$-conflict colorable.\\
Assume that $c$ is a $k$-coloring of $G$, then we can construct a coloring $c'$ of $G'$ as follows: $c'(v') = c(v)$ for any $v\in V$, $c'(a^e_i) = k$ for all $e\in E, i \in [k]$. We can check easily that $c'$ fulfills all edges of $G'$.

Conversely, there is an $\M$-conflict coloring $c'$ of $G'$. Observe that if $c'(u) = i$ (for some $i\in [k]$), then $c'(a^{uv}_i) \in [t,k]$. It implies that $c'(v) \neq i$ because otherwise  $t \geq k/2$, so $va^{uv}_i$ is not fulfilled . Thus, $c'(u) \neq c'(v)$ and we then obtain a coloring $c$ of $G$ by taking $c(v) =c'(v')$ for every $v \in V$.

\bigskip

\noindent {\bf Case 2:} $ 1 \leq m < \dfrac{k}{2}$:\\
We need the following lemma.
\begin{lemma}\label{lem:familyG(k,m)}
There is a graph family $\{G(k,m)\}$ for any $k, m \geq 1$ such that $G(k,m)$ is not $\mathcal{B}(k,m)$-conflict $k$-colorable.
\end{lemma}
\begin{proof}
Given $m \geq 1$, we shall construct a family $\{G(k,m)\}$ and a $k$-SoC $\M$ by induction on $k$. \\
 Let $G(k,m) = (V(k,m), E(k,m))$. Consider the following cases.
\begin{enumerate}
\item[\rm (i)] For $m = k^2$, let $G(k,m)$ on 2 vertices $a_1, a_2$ and it has one edge $a_1a_2$. And let the conflict $k$-graph $M_{a_1a_2} = K^k_{a_1a_2}$ (Figure~\ref{fig:ccnp-case2i}). 
\begin{figure}[h!]
\centerline{
 \includegraphics[scale = 1]{figures/family_m=k2.pdf}}
 \caption{{\bf Graph $G(k,k^2)$.}}
 \label{fig:ccnp-case2i}
\end{figure}

\item[\rm (ii)] For $k^2 >m \geq k$, $G(k,m)$ has $k+1$ vertices $a,a_1,\dots,a_k$ and $k$ edges $aa_i$ for all $i\in [k]$. For each of them, the conflict $k$-graph $M_{aa_i}$ contains $k$ edges $(a,i)(a_i,j)$ for all $j\in [k]$, and $m-k$ other edges are chosen among the other edges of $K^k_{aa_i}$ (Figure~\ref{fig:ccnp-case2ii}).
\begin{figure}[h!]
\centerline{
 \includegraphics[scale = .8]{figures/family_m<k2.pdf}}
 \caption{{\bf An example of graph $G(5,m)$ with 5 colors.} The conflict $5$-graph of red edge $aa_2$, when $m=5$, $M_{aa_2}$ contains five black edges $(a,2)(a_2,i)$ for all $i\in [5]$; and when $m = 7$, then $M_{aa_2}$ contains these black edges and two grey edges which are in the remaining edges of  $K^5_{aa_2}$.}
 \label{fig:ccnp-case2ii}
\end{figure}

\item[\rm (iii)] For $k>m$, $G(k,m)$ is build as follows (Figure~\ref{fig:ccnp-case2iii}). We add $k+1$ vertices $a,a_1,\dots,a_k$ to $V(k,m)$, and add $k$ edges $aa_i$ for all $i\in [k]$ to $E(k,m)$. Now, for each vertex $a_i$, add a set $X_i$ of $|G(k-m,m)|-1$ new vertices, and let a copy $C_i$ of the graph $G(k-m,m)$ on $a_i \cup X_i$. Then, connect $a$ to all vertices of this copy $C_i$.\\
Now, we construct a set of conflict $k$-graphs for $G(k,m)$.  For each edge $ab$ (for every $b \in C_i, 1\leq i \leq k$), the conflict $k$-graph $M_{ab}$ contains $m$ edges $(a,i)(b,j)$ for all $j\in [m]$. In each copy $C_i$, we apply $(k-m)$-SoC $\M'$ of graph $G(k-m,m)$ for $k-m$ colors $\{m+1,\dots,k\}$, if $m \geq (k-m)^2$, then the conflict $(k-m)$-graph $M_{uv}$ for $uv \in C_i$ contains the complete bipartite on two sets $\{(u,m+1),\dots,(u,k)\}, \{(v,m+1),\dots,(v,k)\}$ and  $m-(k-m)^2$ remaining edges are taken in $K^m_{uv}$.
\begin{figure}[h!]
\centerline{
 \includegraphics[scale = 1]{figures/family_m<k.pdf}}
 \caption{{\bf An example of graph $G(5,3)$.} A copy $C_i = G(2,3)$ for all $i \in [5]$. The conflict $k$-graph of red edges and copy $C_2$ (right): vertex $(a,2)$ connects threes first vertices $(b,1), (b,2),(b,3)$ (presented as blue, red, yellow) and the set 2-SoC of $G(2,3)$ is applied to vertices $(b,4),(b,5)$ (presented as green, white) for any $b \in V(C_2)$.}
 \label{fig:ccnp-case2iii}
\end{figure}

\end{enumerate}
Trivially, graphs in case (i) have no $\M$-conflict coloring. \\
In case (ii), $G(k,m)$ has no conflict coloring, since choosing any color $i \in [k]$ for $a$ implies that edge $aa_i$ is not fulfilled.\\
In case (iii), by the construction, colors of $a_1,\dots,a_k$ are not in $[m]$. However, if we choose a color for each $a_i$ in $[m+1,k]$, then it can not fulfill all edges of the copy $C_i$ because $G(k-m,m)$ is not conflict colorable with its $(k-m)$-SoC. Thus, the graphs of this case have no conflict coloring.
\end{proof}

Now, we give a reduction from \textsc{$k$-Coloring} problem to \textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring} for $1 \leq m < k/2$.\\
Given a graph $G = (V, E)$, we  construct a graph $G'= (V',E')$ and a $k$-SoC $\M$ as follows.
\begin{itemize}
\item Let $A$ be a copy of $V$ and add $A$ to $V'$. For each edge $uv \in E$ with $u', v'\in A$ copies of $u,v$, we add $k$ copies $C^{uv}_1,\dots, C^{uv}_k$ of the graph $G(k-2m,m)$, and add edges from each $u', v'$ to all vertices in these $k$ copies. Let $V'_{uv} = \{u', v',V(C^{uv}_1),\dots,V(C^{uv}_k)\}$.
\item For any induced subgraph $G'[V'_{uv}]$, $u'\in A$, $a\in V(C^{uv}_i)$ and $i \in [k]$, the conflict $k$-graph $M_{u'a}$ has $m$ edges $(u,i)(a,1),\dots, (u,i)(a, m)$; and the conflict $k$-graph $M_{v'b}$ for any $b \in V(C^{uv}_j)$, $j\in [k]$ has $m$ edges $(v,j)(b,k),\dots,(v,j)(b,k-m+1)$. In each $C^{uv}_i$, we apply the $(k-2m)$-SoC of the graph $G(k-2m,m)$ for $k-2m$ colors $[m+1,k-m]$.
\end{itemize}
If $G$ has a $k$-coloring $c$ then  we have $c'$ for $G'$ as follows:
 for each $V'_{uv}$, let $c'(v') = c(v)$, $c'(u')= c'(a) = c(u)$ for all $a \in \bigcup\limits_{i\in [k]\setminus c(u)} V(C^{uv}_i)$ and  $c'(a) \in [k,k-m+1] $ for all $a\in V(C^{uv}_{c(u)})$. Hence, $c'$ is a conflict coloring of $G'$.
    
Conversely, assume $G'$ has a $k$-coloring $c'$, then we prove that $c'(u')\neq c'(v')$ for all $u',v' \in A \cap V'_{uv}$. Observe that for any $a \in V(C^{uv}_{c'(u')})$, its color is not in $[k,k-m+1]$ because of the construction of  $C^{uv}_{c(u)}$. Moreover, if $a \in C^{uv}_i$ has color $j \not \in \{m+1,\dots,k-m\}$, then $(a,j)$ is either adjacent to $(u',i)$ in the conflict $k$-graph $M_{ua}$ or $(v,i)$ in $M_{va}$ for $i\in [k]$. Thus $c'(u') \neq c'(v')$. Therefore, we take $c(v) = c'(v')$ for all $v'$ the copy of $v$ and it is a $k$-coloring of $G$.

\bigskip

\noindent {\bf Case 3:} $ (k-1)^2 < m \leq k^2-3$.

We use an induction on $k^2-m$ as follows.
The base case is when $k = 3$ and $1\leq m \leq 6$. From these two cases above, it suffices to prove for $m \in \{5, 6\}$.

\begin{claim}\label{claim:B(3,m)}
\textsc{$\mathcal{B}(3,m)$-Conflict $k$-Coloring} is $\NP$-complete for $m=\{3, 4, 5, 6\}$.
\end{claim}

The inductive result is obtained by the following.
\begin{claim}\label{claim:B(k,m)_3}
If \textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring} is $\NP$-complete, then so is \textsc{$\mathcal{B}(k',m')$-Conflict $k'$-Coloring} for $k'>k$ and $k'^2-m' = k^2-m$.
\end{claim}

Observe that if \textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring} is $\NP$-complete for $1\leq m \leq (k-1)^2$, then  so is \textsc{$\mathcal{B}((k+1),m')$-Conflict $k$-Coloring} by  Claim~\ref{claim:B(k,m)_3} for $m'$ such that $m' = 2k+1+m$, thus $2k+2 \leq m' \leq (k+1)^2-3$. Therefore, we have the following.

\begin{theorem}
\textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring} is $\NP$-complete for $k\geq 3$ and $(k-1)^2 <m \leq k^2-3$.
\end{theorem}
It remains to prove Claim~\ref{claim:B(3,m)} and Claim~\ref{claim:B(k,m)_3}. 

\medskip

\begin{subproof2}{{\it Claim~\ref{claim:B(3,m)}}.}
A reduction from {\sc 3-Coloring}. Given a graph $G=(V, E)$ of this problem, we construct for \textsc{$\mathcal{B}(3,m)$-Conflict $k$-Coloring}, a graph $G'=(V',E')$ and a set of conflict $3$-graphs $\M$ as follows (see Figure \ref{fig:B(3,m)}).

\begin{figure}[h!]
\centerline{
\includegraphics[scale=1.3]{figures/construct(k,m)_2.pdf}}
\caption{{\bf Construction of the reduction.} For each edge $uv\in E(G)$, there is a gadget $\mathcal{G}^{uv}$. And an example on red edges is the structure of their conflict $3$-graphs: it is obligatory that black edges are in conflict 3-graphs while gray ones are not. We obtain that $c(u)=1$ if and only if $c(v) \neq 1$.}
\label{fig:B(3,m)}
\end{figure}
\begin{itemize}
\item For each edge $e=uv \in E$, add a gadget $\mathcal{G}^e$ of 8 vertices $u', v', a^e_1, b^e_1, a^e_2,b^e_2, a^e_3,b^e_3$ to $V'$ where $u', v'$ are respectively copies of $u, v$; and we add to $E'$ edges $ua^e_i, a^e_ib^e_i, b^e_iv$ for all $i\in [3]$.
\item For each induce subgraph $G'[\mathcal{G}^{uv}]$, we construct the conflict $3$-graphs of edges $u'a^{uv}_i,a^{uv}_ib^{uv}_i,b^{uv}_iv'$ for any $i \in [3]$ as follows:
\begin{itemize}
 \item $M_{u'a^{uv}_i}$ contains two edges $(u',i)(a^{uv}_i,1), (u',i)(a^{uv}_i,2)$ and  any $m-2$ other edges is in $K^3_{u'a^{uv}_i}$  except three edges $(u',i)(a^{uv}_i,3), (u',j)(a^{uv}_i,1)$ for $j \neq i $.
 \item $M_{a^{uv}_ib^{uv}_i}$ contains three edges $(a^{uv}_i,2)(b^{uv}_i,3), (a^{uv}_i,3)(b^{uv}_i,2), (a^{uv}_i,3)(b^{uv}_i,3)$ and any $m-3$ other edges in $K^3_{a^{uv}_ib^{uv}_i}$ except two edges $(a^{uv}_i,1)(b^{uv}_i,3), (a^{uv}_i,3)(b^{uv}_i,1)$.
 \item $M_{b^{uv}_iv'}$ contains two edges $(b^{uv}_i,1)(v',i), (b^{uv}_i,2)(v',i)$ and any $m-2$ other ones in $K^3_{b^{uv}_iv'}$ except three edges $(b^{uv}_i,3)(v',i), (b^{uv}_i,1)(v',j)$ for $j \neq i$.
 \end{itemize} 
\end{itemize}
By the construction of $\M$, each conflict graph $M_e \in M$ needs at least three conflict edges and at least three edges not in $M_e$. Thus, $3 \leq m \leq 6$.
\medskip

\noindent We prove now $G$ is 3-colorable if and only if there is $c'$ which fulfills all edges of $G'$.

If $G$ has a $k$-coloring $c$, then $G'$ has also a conflict $k$-coloring by, for all $\mathcal{G}^{uv}$, taking $c'(u') = c(u), c'(v')=c(v), c'(a^{uv}_i)=3, c'(b^{uv}_i)=1$.

Conversely, let a coloring $c'$ which fulfills all edges of $G'$ has a $k$ coloring. Observe that $c'(u) \neq c'(v)$ for any $u,v \in \mathcal{G}^{uv}$ because by the construction of $G'[\mathcal{G}^{uv}]$, if $c'(u')=c'(v')=i$, then three edges $ua^{uv}_i,a^{uv}_ib^{uv}_i,b^{uv}_iv$ are not all fulfilled. Therefore, we define a coloring $c$ of $G$ by taking $c(v)=c'(v')$ for any $v' \in E'$ copy of $v \in E$.
\end{subproof2}


\begin{subproof2}{{\it Claim~\ref{claim:B(k,m)_3}}.}
Let  a graph $G$ and a $k$-SoC $\M$ for \textsc{$\mathcal{B}(k,m)$-Conflict $k$-Coloring}. We will construct for \textsc{$\mathcal{B}(k',m')$-Conflict $k'$-Coloring}, a graph $G' = (V', E')$ and $\M'$, as follows:
\begin{itemize}
\item Let $G'$ be a copy of $G$ (\ie $V', E'$ are respectively copies of $V$ and $E$.
\item For each edge $u'v'$ of $G'$, $M'_{u'v'}$ contains the following: a copy of the conflict graph $M_{uv}$ for colors in $[k]$,  the complete bipartite graph between two sets  $\{(u,i) \mid i\in [k+1,k']\}$ and $\{(v,j) \mid j\in [k'] \}$,  and the complete bipartite graph between two sets $\{(u,j) \mid j\in [k']\}$ and $\{(v,i) \mid i\in [k+1, k]\}$. 
\end{itemize}
If $c$ be a coloring which fulfills all edges of $G$, then taking $c'(v') =c(v)$ for all $v' \in V'$ copy of $c  \in V$. Thus, $c'$ also fulfills all edges of $G'$.

Conversely, there is a coloring $c'$ which fulfills all edges of $G'$. Consider that for  any $u'v'\in E'$, $(v,i)$ is adjacent to $(u,j)$ for all $i \in [k+1,k']$ and $j \in [k']$, then $c'(v') \in [k]$ for all $v'\in V'$. Let $c$ be a coloring of $G$ by taking $c(v) = c'(v')$ for $v \in V$, thus $c$ fulfills all edges of $G'$.
\end{subproof2}


Therefore, we complete the proof of Theorem~\ref{thm:complexity_(k,m)}. It implies that \textsc{$\mathcal{B}(k,m)$-Fulfill $k$-Coloring} is $\NP$-complete for $k\geq 3$ and $1\leq m\leq k^2-3$. 
Moreover, by using the same construction in Claim~\ref{claim:B(k,m)_3}, we make a reduction from \textsc{$\mathcal{B}(2, 4-i)$-Fulfill $k$-Coloring} to \textsc{$\mathcal{B}(k,k^2-i)$-Fulfill $k$-Coloring} for $i \in \{1,2\}$. Thus \textsc{$\mathcal{B}(k,k^2-i)$-Fulfill $k$-Coloring} is $\NP$-complete when $i \in \{1, 2\}$. We obtain the following.

\begin{corollary}
\textsc{$\mathcal{B}(k,m)$-Fulfill $k$-Coloring} is $\NP$-complete for $k\geq 3$ and $m \in [k^2-1]$. 
\end{corollary}
\input{articleCC-experiments}


\section{Conclusion and perspectives}
%%%%%%%%%%%%%%%%%%%%%%%

\paragraph{Computer Science}
We have shown that the coloring problems are very hard in most graph families $\B(k,m)$. 
For a family $\B$ such that {\sc $\B$-Fulfill-$k$-Coloring} is $\NP$-complete and {\sc $\B$-Conflict-$k$-Coloring} is $\Poly$, we can exploit the latter to build an algorithm for solving the former. Assume that $\B$ has the following property: {\em each color of one vertex
typically pairs up with only one color of the other}, this yields the
conflict graph which is a complete bipartite graph minus a matching.  Let
${\cal A}$ the set of graphs obtained from $K_{k,k}$ by deleting a
matching.  One can show that {\sc ${\cal A}$-Conflict Coloring} is
polynomial-time solvable.  Hence, although \textsc{${\cal A}$-Fulfill
  $k$-Coloring} is $\NP$-complete, when the number $q$ of fulfilled
edges is fixed, the problem can be solved in polynomial time. Indeed,
for each of the $O(m^q)$ possible subgraphs $F$ of $G$, one can test
in polynomial time if $F$ admits a $k$-coloring with no
conflict edges.


%% Regarding the experimental part, some further works are presented in
%% Section~\ref{sec:cc_outlook}. In addition, we can also focus on
%% instances which satisfy properties motivated by structural biology and
%% analysis them. \TODO{say something more?}

\paragraph{Computational Structural biology}
A central motivation for this work is the reconstruction of atomic
models of macro molecular assemblies, based on (i) the interaction
graph between subunits, and (ii) one set of conformations (colors) for
each subunit.
%%
Two subunits in contact must exhibit a high steric complementarity,
with in particular little overlap between atoms -- that would
otherwise result in prohibitive van der Waals interaction
energies. For this reason, the resulting conflict $k$-graphs are
almost complete bipartite conflict $k$-graphs.  Interestingly, we have
noticed that in processing instances defined from the Delaunay-Voronoi
setting, which mimics subunits with controlled overlap, a high
fraction of conflict edges does not jeopardize the existence of
solutions.
%%
Our work is therefore compelling in this setting, to process
cases with of the order of tens of subunits, each exhibiting up to
hundreds of conformations. In the longer run, the ability to enumerate
all solutions may serve as a proxy for the free energy of the
assembly, which depends on the population statistics of all valid
conformations.
\toblack

%In Section~\ref{sec:approximation}, we gave a  0.79607-approximation algorithm for {\sc Conflict 2-Coloring}. This
%approximation ratio is proved using an algorithm and analysis which are similar to the ones for {\sc Max Dicut} in \cite{GoWi95}.
%Better SDP-based approximation algorithm for {\sc Max Dicut} have been shown. The current best one is due to 
%Matuura and Matsui~\cite{MaMa01} has an approximation ratio of $0.863$.
%It would be interesting to investigate whether their technique can be generalized for {\sc Fulfill 2-Coloring}.
%It is also natural to try to extend all the approximation algorithms for large value of $k$, that is to approximate {\sc Fulfill $k$-Coloring}.


